//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// Projet : gtsp (voyageur de commerce)
// Date debut projet : 16/12/2002
// Auteur : Olivier Grunder
//
// Version : 0.31
// Date modification : 08/01/2003
// Auteur : Olivier Grunder
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


import java.util.*;
import java.awt.*;
import java.awt.event.* ;
import javax.swing.* ;

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
public class TspJPanelPerf extends JPanel implements Runnable {
    private Thread thread ;
    private JFrame jFrame ;
    private TspSolver solv ;
    private Vector iteration, bestlong ;
    private double longMax=-1, longMin=-1, longueurOpt=-1 ;
    private int attente = 1000 ;
    
    //--------------------------------
    public TspJPanelPerf() { 
    	solv = null ; 
	iteration = new Vector() ; 
	bestlong = new Vector() ;
	setSize(200,100) ;
    } 
    
  public TspJPanelPerf(JFrame jf, TspSolver s, Tsp tsp) { 
        jFrame = jf ;
	solv = s ; 
	iteration = new Vector() ; 
	bestlong = new Vector() ;
	setSize(200,100) ;
    } 

    public void setThread(Thread t) { thread = t ; }
    public void setSolver(TspSolver s) { solv = s ; }

    // ----------------------------------------------------------
    synchronized public void paint(Graphics g) {
        Random rand = new Random() ;


    	int l = getSize().width ;
	int h = getSize().height ;
	// Efface la zone d'affichage
        g.setColor(Color.lightGray);
	g.fillRect(0, 0, l - 1, h - 1);
        g.setColor(Color.black);
        g.drawRect(0, 0, l - 1, h - 1);
	
        if (iteration.size()<=1) return ;
	
	long imax = ((Long)iteration.elementAt(iteration.size()-1)).longValue();
	int x0 = ((Long)iteration.elementAt(0)).intValue() ;
	x0 = (int)((double)x0*(double)l/(double)imax) ;

	int y0 = ((Double)bestlong.elementAt(0)).intValue() ;
	y0 = h-(int)(((double)y0-(double)longMin)*(double)h/((double)longMax-(double)longMin)) ;

	for (int i=1;i<iteration.size()-1;i++) {
		int x1 = ((Long)iteration.elementAt(i)).intValue() ;
		x1 = (int)((double)x1*(double)l/(double)imax) ;

		int y1 = ((Double)bestlong.elementAt(i)).intValue() ;
		y1 = h-(int)(((double)y1-(double)longMin)*(double)h/((double)longMax-(double)longMin)) ;

                // Trace du meilleur parcours
                g.setColor(Color.black);
                g.drawLine(x0, y0, x1, y1) ;

		x0 = x1 ;
		y0 = y1 ;
	}

    }

    //--------------------------------
    // 
    public void run() { 
    	while (thread!=null) {
          try {
            thread.sleep(attente) ;
          }catch(Exception e) {}
          double l=-1 ;
          l=solv.getLongueurOpt() ;
          if ((l>=0) && (l!=longueurOpt)) {
            longueurOpt = l ;
          }
          else {
            l = solv.getBestLongueurCycle() ;
          }
          if (l>=0) {
            //            if ((l==longMin) && (attente<30000)) attente += 500 ;
            if ((longMin<0) || (l<longMin)) longMin = 9*l/10 ;
            if ((longMax<0) || ((l>longMax)&&(l<2*longMin))) longMax = l ;
            iteration.add (new Long(solv.getIter())) ;
            bestlong.add (new Double(l)) ;
            repaint() ;
          }
	}
    }
    
}


