//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// Projet : gtsp (voyageur de commerce)
// Date debut projet : 16/12/2002
// Auteur : Olivier Grunder
//
// Version : 0.12
// Date modification : 17/12/2002
// Auteur : Olivier Grunder
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

import java.util.* ;

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// Solveur Aleat du TSP (Voyageur de commerce)
public class TspSolverAleat extends TspSolver {

  //------------------------------
  public TspSolverAleat (Tsp t) {
    super (t) ;
  }

  //------------------------------
  // Effectue une iteration de recherche
  // renvoie RAFRAICHIR_TOUT si il faut tout rafraichir
  // renvoie RAFRAICHIR_ITER pour rafraichir uniquement le numero d'iteration
  // renvoie STOP si il faut s'arreter
  // renvoie RIEN sinon 
  public int run()
  {
    iter++ ;
    if (init==1) {
      init = 0 ;
      Parcours p = new Parcours (tsp.size(), tsp.getDist()) ;
                        
      p.genereAleat(rand) ;
      p.calculeLongueur() ;

      setSolOpt (p) ;
      return RAFRAICHIR_TOUT ;
    }
    else {
      iterAffichage++ ;
    			
      Parcours p = new Parcours (tsp.size(), tsp.getDist()) ;
      p.genereAleat(rand) ;
    			
      if (p.calculeLongueur()<getLongueurOpt()) {
        setSolOpt (p) ;
        return RAFRAICHIR_TOUT ;
      }
    }
    if (iterAffichage>maxIterAffichage) {
      iterAffichage = 0 ;
      return RAFRAICHIR_ITER ;
    }
    return RIEN ;
  }
	
}
