
public class TspTextMode {

    public static void main(String args[])
    {
	if(args.length != 5)
	    {
		System.out.println("Ce programme ncessite 5 arguments : probleme solution taille_liste_tabou taux_aspiration nb_iteration");
		System.exit(1);
	    }

	String nomPb = new String (args[0]) ;
	String nomSol = new String (args[1]) ;
	String tailleListeTabou = new String(args[2]);
	String tauxAspiration = new String(args[3]);
	String nbIterationsStr = new String(args[4]);

	Tsp tsp = new Tsp(nomPb, nomSol);

	TspSolverTabou st = new TspSolverTabou(tsp);
	st.modifParam(tailleListeTabou, tauxAspiration);

	/* Exemple avec Algo Gntique
	TspSolverAG st = new TspSolverAG(tsp);
	st.modifParam("1000", "1000", "5", "1");
	*/

	int nbIterations = Integer.parseInt(nbIterationsStr);

	while(st.getIter() < nbIterations)
	    {
		st.run();

		if(st.getIter() % 100 == 0)
		    {
			System.err.print(st.getIter() + "\r");
		    }

		System.out.println(st.getIter() + " " + 
				   st.couranteLongueur() + " " +
				   tailleListeTabou + " " +
				   tauxAspiration);
	    }

	System.err.println("\nMeilleure longueur : " + st.meilleureLongueur());
    }
}
